<?php

require_once Config::read('system.dir') . Config::read('system.moduleDir') . 'announcementCategory/class/announcmentCategory.php';
require_once Config::read('system.dir') . Config::read('system.moduleDir') . 'structure/class/structure.php';
require_once Config::read('system.dir') . Config::read('system.moduleDir') . 'geo/class/Geo.php';
require_once Config::read('system.dir') . Config::read('system.moduleDir') . 'function_update_sql.php';

/**
 * Description of annoucment
 *
 * @author IT-Poland.com Jacek Pecko
 */
class Announcement {

    protected $categoryUrl = NULL;
    protected $adsId = NULL;
    protected $title = NULL;
    protected $cityId = NULL;
    protected $createdBy = NULL;
    protected $createdDate = NULL;

    function getAdsId() {
        return $this->adsId;
    }

    function setAdsId($adsId) {
        $this->adsId = $adsId;
        $this->setCategoryUrl($this->readCategpryUrl());
    }

    function getCategoryUrl() {
        return $this->categoryUrl;
    }

    function setCategoryUrl($categoryUrl) {
        $this->categoryUrl = $categoryUrl;
    }

    public function CheckAuthor($anniucmentId) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'announcement';
        $wynik = mysqli_query($dbc, "SELECT `created_by` FROM $tabela WHERE `idrek`='$anniucmentId';");
        $row = mysqli_fetch_array($wynik, MYSQLI_BOTH);
        return $row['created_by'];
    }

    public function getAnnoucementByHash($hash) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'announcement';
        $wynik = mysqli_query($dbc, "SELECT `idrek` FROM $tabela WHERE `hash`='$hash' and `active` = 'Y' and (`status` != 'DEL');");
        $row = mysqli_fetch_array($wynik, MYSQLI_BOTH);
        if ($row) {
            return $this->getAnnoucement($row['idrek']);
        } else {
            return false;
        }
    }

    public function getAnnoucementPrice($idrek) {
        global $dbc;
        $catId = $this->getAnnoucementCategory($idrek);
        if ($catId > 0) {
            $categoryObj = new announcmentCategory();
            $category = $categoryObj->getCategory($catId);
            for ($i = 0; $i < count($category['fields']); $i++) {
                if ($category['fields'][$i]['specName'] == 'price') {
                    $tabela = Config::read('db.prefix') . 'announcement_fields_txt_val';
                    $wynik = mysqli_query($dbc, "SELECT `value` FROM $tabela WHERE `fieldId`='" . $category['fields'][$i]['idrek'] . "' AND `annId`='" . $idrek . "';");
                    $row2 = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
                    return $row2['value'];
                }
            }
            return false;
        } else {
            return FALSE;
        }
    }

    public function getAnnoucementCategory($idrek) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'announcement';
        $wynik = mysqli_query($dbc, "SELECT `catId` FROM $tabela WHERE `idrek`='$idrek';");
        $row = mysqli_fetch_array($wynik, MYSQLI_BOTH);
        if ($row)
            return $row['catId'];
        else
            return FALSE;
    }

    public function getAnnoucement($idrek) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'announcement';
        $wynik = mysqli_query($dbc, "SELECT * FROM $tabela WHERE `idrek`='$idrek';");
        $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);


        if ($row['active'] == 'Y' and ( $row['endDate'] > mktime() OR $row['endDate'] == 0) and ( $row['status'] == 'NEW' OR $row['status'] == 'ACCEPT'))
            $row['acitve'] = true;
        else
            $row['acitve'] = false;

        //pobieranie danych o kategorii
        $categoryObj = new announcmentCategory();
        $category = $categoryObj->getCategory($row['catId']);

        $row['category'] = $category;
        $row['fields'] = array();


        for ($i = 0; $i < count($category['fields']); $i++) {
            $row['fields'][$i] = $category['fields'][$i];
            $row['fields'][$i]['isNotNull'] = false;
            if ($category['fields'][$i]['type'] == 'txt') {
                $tabela = Config::read('db.prefix') . 'announcement_fields_txt_val';
                $wynik = mysqli_query($dbc, "SELECT `value` FROM $tabela WHERE `fieldId`='" . $category['fields'][$i]['idrek'] . "' AND `annId`='" . $idrek . "';");
                $row2 = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
                $row['fields'][$i]['value'] = $row2['value'];
                if (strlen($row2['value']) > 0)
                    $row['fields'][$i]['isNotNull'] = true;
            } else if ($category['fields'][$i]['type'] == 'textarea') {
                $tabela = Config::read('db.prefix') . 'announcement_fields_textarea_val';
                $wynik = mysqli_query($dbc, "SELECT `value` FROM $tabela WHERE `fieldId`='" . $category['fields'][$i]['idrek'] . "' AND `annId`='" . $idrek . "';");
                $row2 = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
                $row['fields'][$i]['value'] = $row2['value'];
                if (strlen($row2['value']) > 0)
                    $row['fields'][$i]['isNotNull'] = true;
            } else if ($category['fields'][$i]['type'] == 'multiselect') {
                for ($iSel = 0; $iSel < count($category['fields'][$i]['option']); $iSel++) {
                    $tabela = Config::read('db.prefix') . 'announcement_fields_multi_val';
                    $wynik = mysqli_query($dbc, "SELECT `idrek` FROM $tabela WHERE `fieldId`='" . $category['fields'][$i]['idrek'] . "' AND `annId`='" . $idrek . "'  AND `optionId`='" . $category['fields'][$i]['option'][$iSel]['id'] . "';");
                    $row2 = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
                    if ($row2['idrek'] > 0) {
                        $row['fields'][$i]['option'][$iSel]['selected'] = true;
                        $row['fields'][$i]['isNotNull'] = true;
                    }
                }
            }
        }

        $row['photos'] = $this->getPhotos($idrek);
        return $row;
    }

    public function getPhotos($idAnnoucment) {
        global $dbc;
        $arr = array();
        $tabela = Config::read('db.prefix') . 'announcement_photos';
        $wynik = mysqli_query($dbc, "SELECT `photoId` FROM $tabela where `annId`='" . $idAnnoucment . "';");
        while ($rekord = mysqli_fetch_array($wynik, MYSQLI_ASSOC)) {
            array_push($arr, $rekord['photoId']);
        }
        if (count($arr) < 1)
            return NULL;
        else
            return $arr;
    }

    public function getPermaLink($idrek) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'announcement';
        $wynik = mysqli_query($dbc, "SELECT `permalink` FROM $tabela WHERE `idrek`='$idrek';");
        $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
        return $row['permalink'];
    }

    /* Zmienione założenia, aby zrezygnować z funckji getURL2, getUrl3 itd... */

    public function getUrl($idrek, $opt = FALSE) {
        global $dbc;
        $catId = $this->getCategory($idrek);
        if ($catId == 0 or $catId == NULL or $catId == 3603)
            $catId = Config::read('announcment.DefaultCategory');
        $categoryUrl = announcmentCategory::getCategoryUrl($catId);
        if ($categoryUrl != NULL)
            if ($opt == FALSE)
                return $categoryUrl . 'p,' . $this->getPermaLink($idrek) . ',ogloszenie,' . $idrek . '.html';
            else
                return $categoryUrl . 'p,' . $this->getPermaLink($idrek) . ',ogloszenie,' . $idrek . ',opt,' . $opt . '.html';
        else
            return FALSE;
    }

    public function getUrl2($idrek) {
        global $dbc;
        $catId = $this->getCategory($idrek);
        $categoryUrl = announcmentCategory::getCategoryUrl($catId);
        if ($categoryUrl != NULL)
            return $categoryUrl . 'p,' . $this->getPermaLink($idrek) . ',ogloszenie,' . $idrek . ',opt,2.html';
        else
            return FALSE;
    }

    public function getUrl3($idrek) {
        global $dbc;
        $catId = $this->getCategory($idrek);
        $categoryUrl = announcmentCategory::getCategoryUrl($catId);
        if ($categoryUrl != NULL)
            return $categoryUrl . 'p,' . $this->getPermaLink($idrek) . ',ogloszenie,' . $idrek . ',opt,3.html';
        else
            return FALSE;
    }

    public function getUrl4($idrek) {
        global $dbc;
        $catId = $this->getCategory($idrek);
        $categoryUrl = announcmentCategory::getCategoryUrl($catId);
        if ($categoryUrl != NULL)
            return $categoryUrl . 'p,' . $this->getPermaLink($idrek) . ',ogloszenie,' . $idrek . ',opt,4.html';
        else
            return FALSE;
    }

    public function getUrlOldId($idrek) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'announcement';
        $wynik = mysqli_query($dbc, "SELECT `idrek` FROM $tabela WHERE `oldID`='$idrek';");
        $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
        if ($row['idrek'] > 0) {
            return $this->getUrl($row['idrek']);
        } else {
            return false;
        }
    }

    public function getCategory($idrek) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'announcement';
        $wynik = mysqli_query($dbc, "SELECT `catId` FROM $tabela WHERE `idrek`='$idrek';");
        $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
        if ($row['catId'] > 0)
            return $row['catId'];
        else
            return FALSE;
    }

    public function getReason($idrek) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'announcement_reason';
        $wynik = mysqli_query($dbc, "SELECT `text`, `created_date`, `created_by` FROM $tabela WHERE `idAnnoucment`='$idrek' order by `created_date` DESC LIMIT 0,1;");
        $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
        if (mysql_num_rows($wynik) > 0) {
            $row['text'] = nl2br($row['text']);
            return $row;
        } else {
            return FALSE;
        }
    }

    public function changeVisible($idrek) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'announcement';
        $row_name = array();
        $row_value = array();
        if ($this->getVisible($idrek) == 'Y') {
            array_push($row_name, 'active');
            array_push($row_value, 'N');
            echo '<a href="javascript:void(0);" onclick="change_me_status(\'annoucmentShow\', \'Y\', \'active\', ' . $idrek . ');" title="Kliknij, aby aktywować.">Nie</a>';
        } else {
            array_push($row_name, 'active');
            array_push($row_value, 'Y');
            echo '<a href="javascript:void(0);" onclick="change_me_status(\'annoucmentShow\', \'N\', \'active\', ' . $idrek . ');" title="Kliknij, aby dezaktywować.">Tak</a>';
        }
        update_sql($tabela, $row_name, $row_value, '`idrek` = \'' . $idrek . '\'');
    }

    public function getVisible($annoucmentId) {
        global $dbc;
        $timeNow = mktime();
        $tabela = Config::read('db.prefix') . 'announcement';
        $wynik = mysqli_query($dbc, "SELECT `active` FROM $tabela WHERE `idrek`='$annoucmentId' AND (`endDate` > " . $timeNow . " OR `endDate` IS NULL OR `endDate` = 0);");
        $row = mysqli_fetch_array($wynik, MYSQLI_BOTH);
        return $row['active'];
    }

    public function getAnnoucementByCatId($catId = FALSE, $elements = 10, $pages = 0, $sortBy = 'created_date', $sordOrder = 'DESC') {
        global $dbc;
        $catQuery = '';
        if ($catId != FALSE) {
            $catObj = new announcmentCategory();
            $catArr = $catObj->getIdChildCat($catId);

            $catQuery = "`catId`='" . $_GET['what'] . "'";
            for ($i = 0; $i < count($catArr); $i++) {
                $catQuery.= " OR `catId`='" . $catArr[$i] . "' ";
            }
        } else {
            $catQuery = ' 1=1';
        }

        $timeNow = mktime();
        $zapytanie = " WHERE (" . $catQuery . ") AND (`status` = 'ACCEPT' OR  `status` = 'NEW') AND  `active` = 'Y'  AND (`endDate` > " . $timeNow . ' OR `endDate` = 0 OR `endDate` IS NULL) ';

        $elements = array();
        $licznik = 0;
        $tabela = Config::read('db.prefix') . 'announcement';
        $wynik = mysqli_query($dbc, "SELECT `idrek`, `catId`, `title`, `created_by`, `created_date`  FROM $tabela $zapytanie  ORDER BY `$sortBy` $sordOrder LIMIT  $pages,$limit;");
        while ($rekord = mysqli_fetch_array($wynik, MYSQLI_ASSOC)) {
            $elements[$licznik] = $rekord;
            $licznik++;
        }

        return $elements;
    }

    public function getAnnouncmentList($catId, $paging = 'Y', $numberbysite = 10, $siteNr = 1, $sortBy = 'created_date', $sortOrder = 'ASC', $activeOnly = true, $query = '') {
        global $dbc;
        $elements = array();
        $catObj = new announcmentCategory();
        $catArr = $catObj->getIdChildCat($catId);

        //$catFields = $catObj->getCategoryFields($catId, TRUE);

        $catQuery = "`catId`='" . $catId . "'";
        for ($i = 0; $i < count($catArr); $i++) {
            $catQuery.= " OR `catId`='" . $catArr[$i] . "' ";
        }

        $query_sql = '';
        if (strlen($query) > 1) {
            $query_sql = " AND ($query) ";
        }



        $tabela = Config::read('db.prefix') . 'announcement';
        if ($activeOnly == true) {
            $timeNow = mktime();
            $zapytanie = " WHERE ($catQuery) $query_sql AND `step` = '4' AND (`status` = 'ACCEPT' OR  `status` = 'NEW') AND `active` = 'Y' AND (`endDate` > " . $timeNow . ' OR `endDate` = 0 OR `endDate` IS NULL) ';
        } else
            $zapytanie = " WHERE ($catQuery) $query_sql ";

        if ($sortOrder == 'down')
            $sortOrder = 'DESC';
        else if ($sortOrder == 'up')
            $sortOrder = 'ASC';

        if ($sortBy == 'date')
            $sortBy = 'created_date';
        else
            $sortBy = 'title';

        $zapytanie .= " ORDER BY $sortBy $sortOrder ";


        $ile = $this->getAnnouncmentListCount($catId, $query, $activeOnly);

        if ($paging == "Y") {
            $stron = $this->getAnnoucmentSites($ile, $numberbysite);
            $od_ilu = ($siteNr - 1) * $numberbysite;
            //koniec stronicowanie
            $wynik = mysqli_query($dbc, "SELECT * FROM " . $tabela . " $zapytanie LIMIT $od_ilu, " . $numberbysite . ";");
        } else {
            $wynik = mysqli_query($dbc, "SELECT * FROM " . $tabela . " $zapytanie LIMIT 0, $numberbysite ;");
        }

        $licznik = 0;
        while ($row = mysqli_fetch_array($wynik, MYSQLI_ASSOC)) {
            $catFields = $catObj->getCategoryFields($row['catId'], TRUE);
            $elements[$licznik] = $row;
            $elements[$licznik]['url'] = $this->getUrl($elements[$licznik]['idrek']);
            $elements[$licznik]['url2'] = $this->getUrl($elements[$licznik]['idrek'], 2);
            $elements[$licznik]['url3'] = $this->getUrl($elements[$licznik]['idrek'], 3);
            $elements[$licznik]['url4'] = $this->getUrl($elements[$licznik]['idrek'], 4);
            $elements[$licznik]['url5'] = $this->getUrl($elements[$licznik]['idrek'], 5);
            $elements[$licznik]['photos'] = $this->getPhotos($elements[$licznik]['idrek']);

            //kategoria
            $catObj = new announcmentCategory;
            $elements[$licznik]['category'] = $catObj->getCategory($row['catId']);
            //kategoria KONIEC
            //geo
            $geoObj = new Geo;
            $elements[$licznik]['city'] = $geoObj->getCity($row['cityId']);
            //geo KONIEC
            //pobiernianie wartości specjalnych
            $specFieldArr = array();
            for ($i = 0; $i < count($catFields); $i++) {
                $elements[$licznik]['specField'][$catFields[$i]['specName']] = $this->getFieldValue($elements[$licznik]['idrek'], $catFields[$i]['idrek']);
                if (isset($catFields[$i]['specName'])) {
                    $elements[$licznik]['specField'][$catFields[$i]['specName']]['specTitle'] = $catFields[$i]['specTitle'];
                }
            }

            //utworzone
            if ($row['created_by'] > 0) {
                $user_id = $row['created_by'];
                $tabela_user = Config::read('db.prefix') . 'users';
                $wynik_user = mysqli_query($dbc, "SELECT `nick` FROM $tabela_user WHERE `idrek`='$user_id';");
                $row_user = mysqli_fetch_array($wynik_user, MYSQLI_NUM);
                $elements[$licznik]['created_by_name'] = $row_user[0];
                $elements[$licznik]['created_by_id'] = $user_id;
            }
            if ($row['modifited_by'] > 0) {
                $user_id = $row['modifited_by'];
                $tabela_user = Config::read('db.prefix') . 'users';
                $wynik_user = mysqli_query($dbc, "SELECT `nick` FROM $tabela_user WHERE `idrek`='$user_id';");
                $row_user = mysqli_fetch_array($wynik_user, MYSQLI_NUM);
                $elements[$licznik]['modifited_by_name'] = $row_user[0];
                $elements[$licznik]['modifited_by_id'] = $user_id;
            }

            //wyciąganie opisanych pól
            $tabelaFields = Config::read('db.prefix') . 'announcement';


            $licznik++;
        }
        return $elements;
    }

    public function getAnnouncmentListCount($catId, $query = '', $activeOnly = true) {
        global $dbc;
        $catQuery = "`catId`='" . $catId . "'";

        $catObj = new announcmentCategory();
        $catArr = $catObj->getIdChildCat($catId);


        for ($i = 0; $i < count($catArr); $i++) {
            $catQuery.= " OR `catId`='" . $catArr[$i] . "' ";
        }


        $query_sql = '';
        if (strlen($query) > 1) {
            $query_sql = " AND ($query) ";
        }


        $tabela = Config::read('db.prefix') . 'announcement';
        if ($activeOnly == true) {
            $timeNow = mktime();
            $zapytanie = " WHERE ($catQuery) $query_sql AND `step` = '4' AND (`status` = 'ACCEPT' OR  `status` = 'NEW') AND `active` = 'Y'  AND (`endDate` > " . $timeNow . ' OR `endDate` = 0 OR `endDate` IS NULL) ';
        } else
            $zapytanie = " WHERE ($catQuery $query_sql)";

        $dane = mysqli_query($dbc, "SELECT COUNT(*) FROM $tabela $zapytanie;");
        $row2 = mysqli_fetch_array($dane);

        return $row2[0];
    }

    public function getAnnoucmentSites($ile, $numberBySite) {
        global $dbc;
        $stron = $ile / $numberBySite;
        $stron = ceil($stron);

        return $stron;
    }

    public function getAnnoucmentType() {
        global $dbc;
        $elements = array();
        $tabela = Config::read('db.prefix') . 'announcement_type';
        $wynik = mysqli_query($dbc, "SELECT `idrek`, `name`, `title` FROM " . $tabela . ";");
        while ($row = mysqli_fetch_array($wynik, MYSQLI_ASSOC)) {
            array_push($elements, $row);
        }
        return $elements;
    }

    public function getFieldValue($annoucmentId, $filedId) {
        global $dbc;
        $fieldArr = array();
        $tabela = Config::read('db.prefix') . 'announcement_fields';
        $dane = mysqli_query($dbc, "SELECT `type`, `show_name` FROM $tabela WHERE `idrek` = '$filedId';");
        $row = mysqli_fetch_array($dane);
        $fieldArr['fieldId'] = $filedId;
        $fieldArr['type'] = $row['type'];
        $fieldArr['show_name'] = $row['show_name'];
        if ($fieldArr['type'] == 'txt') {
            $tabela = Config::read('db.prefix') . 'announcement_fields_txt_val';
            $dane = mysqli_query($dbc, "SELECT `value` FROM $tabela WHERE `annId` = '$annoucmentId' AND `fieldId` = '$filedId';");
            $row = mysqli_fetch_array($dane);
            $fieldArr['value'] = $row['value'];
        } else if ($fieldArr['type'] == 'textarea') {
            $tabela = Config::read('db.prefix') . 'announcement_fields_textarea_val';
            $dane = mysqli_query($dbc, "SELECT `value` FROM $tabela WHERE `annId` = '$annoucmentId' AND `fieldId` = '$filedId';");
            $row = mysqli_fetch_array($dane);
            $fieldArr['value'] = $row['value'];
        } else if ($fieldArr['type'] == 'multiselect') {
            $fieldArr['option'] = array();
            $licznik2 = 0;
            $tabela = Config::read('db.prefix') . 'announcement_fields_multi_val';
            $wynik = mysqli_query($dbc, "SELECT `optionId`  FROM $tabela where `annId` = '$annoucmentId' AND `fieldId` = '$filedId';");
            while ($rekord = mysqli_fetch_array($wynik, MYSQLI_ASSOC)) {
                $tabela2 = Config::read('db.prefix') . 'announcement_fields_multi';
                $dane2 = mysqli_query($dbc, "SELECT `name`, `value` FROM $tabela2 WHERE `idrek` = '" . $rekord['optionId'] . "';");
                $row2 = mysqli_fetch_array($dane2);

                $fieldArr['option'][$licznik2]['name'] = $row2['name'];
                $fieldArr['option'][$licznik2]['value'] = $row2['value'];
                $licznik2 ++;
            }
        }
        return $fieldArr;
    }

    /* generowanie urla do kategorii z ogøoszeniem */

    public function readCategpryUrl() {
        global $dbc;
        $idrek = $this->adsId;
        $tabela = Config::read('db.prefix') . 'announcement';
        $wynik = mysqli_query($dbc, "SELECT `catId` FROM $tabela WHERE `idrek`='$idrek';");
        $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
        if ($row['catId']) {
            $tabela = Config::read('db.prefix') . 'announcement_structure';
            $wynik = mysqli_query($dbc, "SELECT `structureid` FROM $tabela WHERE `idrek`='" . $row['catId'] . "';");
            $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);

            return isset($_SERVER["https"]) ? 'https' : 'http' . '://' . structure::getAdressById($row['structureid']);
        } else {
            return FALSE;
        }
    }

    function getTitle($idrek) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'announcement';
        $wynik = mysqli_query($dbc, "SELECT `title` FROM $tabela WHERE `idrek`='$idrek';");
        $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
        return $row['title'];
    }

    function getCityId($idrek) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'announcement';
        $wynik = mysqli_query($dbc, "SELECT `cityId` FROM $tabela WHERE `idrek`='$idrek';");
        $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
        $this->cityId = $row['cityId'];
        return $this->cityId;
    }

    function getCreatedBy($idrek) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'announcement';
        $wynik = mysqli_query($dbc, "SELECT `created_by` FROM $tabela WHERE `idrek`='$idrek';");
        $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
        $this->createdBy = $row['created_by'];
        return $this->createdBy;
    }

    function getCreatedDate($idrek) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'announcement';
        $wynik = mysqli_query($dbc, "SELECT `created_date` FROM $tabela WHERE `idrek`='$idrek';");
        $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
        $this->createdDate = $row['created_date'];
        return $this->createdDate;
    }

    public function activateAnnoucment($hash) {
        global $dbc;
        global $smarty;
        $tabela = Config::read('db.prefix') . 'announcement';
        $wynik = mysqli_query($dbc, "SELECT `idrek`, `email` FROM $tabela WHERE `hash`='$hash' and `status` = 'NEW';");
        $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
        if ($row['idrek'] > 0) {
            $row_name = array();
            $row_value = array();
            array_push($row_name, 'active');
            array_push($row_value, 'Y');
            update_sql($tabela, $row_name, $row_value, '`hash`=\'' . $hash . '\'');
            $content_mail = '<h1>Twoje ogłoszenie zostało aktywowane</h1><br /><br />'
                    . 'Poniżej znajduje się link, który pozwoli edytować je:<br />'
                    . '<a href="http://' . Config::read('site.domain') . '/ogloszenia/edycja-ogloszenia/h,' . $hash . '.html">http://' . Config::read('site.domain') . '/ogloszenia/edycja-ogloszenia/h,' . $hash . '.html</a><br /><br />'
                    . 'pozdrawiamy<br />'
                    . 'Zespół Web-Rynek.pl';
            $smarty->assign("content", $content_mail);
            $content_mail = $smarty->fetch(Config::read('system.frontTemplate') . '/' . Config::read('system.emailTemplate') . '.tpl.html');
            send_mail($row['email'], Config::read('email.name'), Config::read('email.adress'), 'Ogłoszenie zostało aktywowane', $content_mail);


            return true;
        } else {
            return false;
        }
    }

    public function getIdByHash($hash) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'announcement';
        $wynik = mysqli_query($dbc, "SELECT `idrek` FROM $tabela WHERE `hash`='$hash';");
        $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
        return $row['idrek'];
    }

    public function getIsActive($idrek) {
        global $dbc;
        $timeNow = mktime();
        $tabela = Config::read('db.prefix') . 'announcement';
        $wynik = mysqli_query($dbc, "SELECT `idrek` FROM $tabela WHERE `idrek`='$idrek' AND (`status` = 'ACCEPT' OR  `status` = 'NEW') AND  `active` = 'Y'  AND (`endDate` > " . $timeNow . " OR `endDate` = 0 OR `endDate` IS NULL);");
        $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
        if ($row)
            return true;
        else
            return false;
    }

}
