<?php
 
class yahoo_weather {
 
  public $city_code;
  protected $weather;
 
  public function __construct($city_code) {
    $this->city_code = $city_code;
  }
 
  public function get($get_channel = NULL) {
 
    if(empty($this->weather)) {
 
      try {
        $xml = @new SimpleXMLElement('http://weather.yahooapis.com/forecastrss?w='. $this->city_code .'&u=c', NULL, TRUE);
      } catch (Exception $e) {
        return FALSE;
      }
 
      $xml->registerXpathNamespace('yweather', 'http://xml.weather.yahoo.com/ns/rss/1.0');
 
      $wind       = $xml->xpath('//channel/yweather:wind');
      $atmosphere = $xml->xpath('//channel/yweather:atmosphere');
      $astronomy  = $xml->xpath('//channel/yweather:astronomy');
      $condition  = $xml->xpath('//channel/item/yweather:condition');
      $forecast   = $xml->xpath('//channel/item/yweather:forecast');
 
      $this->weather = array(
        'wind'       => array(
          'chill'      => "{$wind[0]['chill']}",
          'direction'  => "{$wind[0]['direction']}",
          'speed'      => "{$wind[0]['speed']}",
          ),
        'atmosphere' => array(
          'humidity'   => "{$atmosphere[0]['humidity']}",
          'visibility' => "{$atmosphere[0]['visibility']}",
          'pressure'   => "{$atmosphere[0]['pressure']}",
          'rising'     => "{$atmosphere[0]['rising']}",
        ),
        'astronomy'  => array(
          'sunrise'    => "{$astronomy[0]['sunrise']}",
          'sunset'     => "{$astronomy[0]['sunset']}",
        ),
        'condition'  => array(
          'text'       => "{$condition[0]['text']}",
          'code'       => "{$condition[0]['code']}",
          'temp'       => "{$condition[0]['temp']}",
          'date'       => "{$condition[0]['date']}",
        ),
        'forecast'   => array(
          'today'      => array(
            'day'        => "{$forecast[0]['day']}",
            'date'       => "{$forecast[0]['date']}",
            'low'        => "{$forecast[0]['low']}",
            'high'       => "{$forecast[0]['high']}",
            'text'       => "{$forecast[0]['text']}",
            'code'       => "{$forecast[0]['code']}",
          ),
          'tomorrow'   => array(
            'day'        => "{$forecast[1]['day']}",
            'date'       => "{$forecast[1]['date']}",
            'low'        => "{$forecast[1]['low']}",
            'high'       => "{$forecast[1]['high']}",
            'text'       => "{$forecast[1]['text']}",
            'code'       => "{$forecast[1]['code']}",
          )
        )
      );
 
      $xml = NULL;
    }
 
    if($get_channel == NULL) {
      return $this->weather;
    }
    else {
      return $this->weather[$get_channel];
    }
  }
}
