<?php

class counters {

    private $tableOldUser, $tableUser, $tableCounters, $dbc, $tableCategory;

    function __construct() {
        global $dbc;
        $this->dbc = $dbc;
        $this->tableCounters = Config::read('db.prefix') . 'counters';
        $this->tableCategory = Config::read('db.prefix') . 'countersCategory';
    }

    public function addCounter($param, $type) {
        $row_name = array();
        $row_value = array();

        array_push($row_name, 'nazwa');
        array_push($row_value, addslashes($param['nazwa']));
        array_push($row_name, 'kogo');
        array_push($row_value, Config::read('user.id'));
        array_push($row_name, 'wartosc');
        array_push($row_value, addslashes($param['wartosc']));
        array_push($row_name, 'powiadomienie');
        array_push($row_value, addslashes($param['powiadomienie']));
        array_push($row_name, 'data_utw');
        array_push($row_value, "NOW()");
        array_push($row_name, 'category');
        array_push($row_value, addslashes($param['category']));
        array_push($row_name, 'rodzaj');
        array_push($row_value, $type);
        array_push($row_name, 'hash');
        array_push($row_value,  md5(uniqid(time()+rand(0,10000), true)));        
       
        
        if ($type == 1) {  //licznik tekstowy
            array_push($row_name, 'czcion_wielkosc');
            array_push($row_value, addslashes($param['czcion_wielkosc']));
            array_push($row_name, 'czcion_kolor');
            array_push($row_value, addslashes($param['czcion_kolor']));
            array_push($row_name, 'czcion_kroj');
            array_push($row_value, addslashes($param['czcion_kroj']));
            if ($param['bui_b'] == 1) {
                $bui_b = 1;
            } else {
                $bui_b = 0;
            }

            if ($param['bui_u'] == 1) {
                $bui_u = 1;
            } else {
                $bui_u = 0;
            }

            if ($param['bui_i'] == 1) {
                $bui_i = 1;
            } else {
                $bui_i = 0;
            }

            array_push($row_name, 'czacion_bui');
            array_push($row_value, $bui_b . '-' . $bui_u . '-' . $bui_i);
        } else if ($type == 2) {
            array_push($row_name, 'graf_ktory');
            array_push($row_value, addslashes($param['graf_ktory']));
        } else if ($type == 3) {
            array_push($row_name, 'wys_flash');
            array_push($row_value, addslashes($param['wys_flash']));
            array_push($row_name, 'sze_flash');
            array_push($row_value, addslashes($param['sze_flash']));
            array_push($row_name, 'licznik_flash');
            array_push($row_value, addslashes($param['licznik_flash']));
        }
        return insert_sql($this->tableCounters, $row_name, $row_value);
    }

    public function updateCounter($param, $idrek) {
        $row_name = array();
        $row_value = array();

        array_push($row_name, 'nazwa');
        array_push($row_value, addslashes($param['nazwa']));
        array_push($row_name, 'kogo');
        array_push($row_value, Config::read('user.id'));
        array_push($row_name, 'wartosc');
        array_push($row_value, addslashes($param['wartosc']));
        array_push($row_name, 'powiadomienie');
        array_push($row_value, addslashes($param['powiadomienie']));
        array_push($row_name, 'category');
        array_push($row_value, addslashes($param['category']));
        if ($param['rodzaj'] == 1) {  //licznik tekstowy
            array_push($row_name, 'czcion_wielkosc');
            array_push($row_value, addslashes($param['czcion_wielkosc']));
            array_push($row_name, 'czcion_kolor');
            array_push($row_value, addslashes($param['czcion_kolor']));
            array_push($row_name, 'czcion_kroj');
            array_push($row_value, addslashes($param['czcion_kroj']));
            if ($param['bui_b'] == 1) {
                $bui_b = 1;
            } else {
                $bui_b = 0;
            }

            if ($param['bui_u'] == 1) {
                $bui_u = 1;
            } else {
                $bui_u = 0;
            }

            if ($param['bui_i'] == 1) {
                $bui_i = 1;
            } else {
                $bui_i = 0;
            }

            array_push($row_name, 'czacion_bui');
            array_push($row_value, $bui_b . '-' . $bui_u . '-' . $bui_i);
        } else if ($param['rodzaj'] == 2) {
            array_push($row_name, 'graf_ktory');
            array_push($row_value, addslashes($param['graf_ktory']));
        } else if ($param['rodzaj'] == 3) {
            array_push($row_name, 'wys_flash');
            array_push($row_value, addslashes($param['wys_flash']));
            array_push($row_name, 'sze_flash');
            array_push($row_value, addslashes($param['sze_flash']));
            array_push($row_name, 'licznik_flash');
            array_push($row_value, addslashes($param['licznik_flash']));
        }

        return update_sql($this->tableCounters, $row_name, $row_value, '`id`=\'' . $idrek . '\' AND `kogo`=\'' . Config::read('user.id') . '\'  ');
    }

    public function getCategories() {
        $arr = array();
        $wynik = mysqli_query($this->dbc, "SELECT * FROM $this->tableCategory ORDER BY `name`;");
        while ($rekord = mysqli_fetch_array($wynik, MYSQLI_ASSOC)) {
            array_push($arr, $rekord);
        }
        return $arr;
    }

    public function getList($paging = 'Y', $numberbysite = 10, $siteNr = 1, $sortBy = 'created_date', $sortOrder = 'ASC') {
        $elements = array();
        $zapytanie = " WHERE `kogo` = '" . Config::read('user.id') . "' ";

        if ($sortOrder == 'down')
            $sortOrder = 'DESC';
        else if ($sortOrder == 'up')
            $sortOrder = 'ASC';
        if ($sortBy == 'date')
            $sortBy = 'data_utw';
        else
            $sortBy = 'nazwa';

        $zapytanie .= " ORDER BY $sortBy $sortOrder ";


        if ($paging == "Y") {
            $stron = $this->getSites($ile, $numberbysite);
            $od_ilu = ($siteNr - 1) * $numberbysite;

            $wynik = mysqli_query($this->dbc, "SELECT `id`, `wartosc`, `rodzaj`, `nazwa`, `data_utw` FROM " . $this->tableCounters . " $zapytanie LIMIT $od_ilu, " . $numberbysite . ";");
        } else {
            $wynik = mysqli_query($this->dbc, "SELECT  `id`, `wartosc`, `rodzaj`, `nazwa`, `data_utw` FROM " . $this->tableCounters . " $zapytanie LIMIT 0, $numberbysite ;");
        }


        $licznik = 0;
        while ($row = mysqli_fetch_array($wynik, MYSQLI_ASSOC)) {
            $elements[$licznik] = $row;
            $licznik++;
        }

        return $elements;
    }

    public function getSites($ile, $numberBySite) {
        $stron = $ile / $numberBySite;
        $stron = ceil($stron);

        return $stron;
    }

    public function getListCount() {
        $zapytanie = " WHERE `kogo` = '" . Config::read('user.id') . "' ";
        $dane = mysqli_query($this->dbc, "SELECT COUNT(*) FROM $this->tableCounters $zapytanie;");
        $row2 = mysqli_fetch_array($dane);

        return $row2[0];
    }

    public function getCounter($idrek) {
        $zapytanie = " WHERE `kogo` = '" . Config::read('user.id') . "' AND `id` = '$idrek'";
        $dane = mysqli_query($this->dbc, "SELECT * FROM $this->tableCounters $zapytanie;");
        $row = mysqli_fetch_array($dane, MYSQLI_ASSOC);
        $temp = explode('-', $row['czacion_bui']);
        $row['bui_b'] = $temp[0];
        $row['bui_u'] = $temp[1];
        $row['bui_i'] = $temp[2];


        if ($row['wys_flash'] == 150) {
            $row['licznikAnimSkala'] = 1;
        } else if ($row['wys_flash'] == 225) {
            $row['licznikAnimSkala'] = 2;
        } else if ($row['wys_flash'] == 300) {
            $row['licznikAnimSkala'] = 3;
        } else if ($row['wys_flash'] == 375) {
            $row['licznikAnimSkala'] = 4;
        } else if ($row['wys_flash'] == 450) {
            $row['licznikAnimSkala'] = 5;
        } else if ($row['wys_flash'] == 525) {
            $row['licznikAnimSkala'] = 6;
        } else if ($row['wys_flash'] == 600) {
            $row['licznikAnimSkala'] = 7;
        } else if ($row['wys_flash'] == 675) {
            $row['licznikAnimSkala'] = 8;
        } else if ($row['wys_flash'] == 750) {
            $row['licznikAnimSkala'] = 9;
        } else if ($row['wys_flash'] == 825) {
            $row['licznikAnimSkala'] = 10;
        }

        return $row;
    }

    public function getCounterType($idrek) {
        $zapytanie = " WHERE `kogo` = '" . Config::read('user.id') . "' AND `id` = '$idrek'";
        $dane = mysqli_query($this->dbc, "SELECT `rodzaj` FROM $this->tableCounters $zapytanie;");
        $row = mysqli_fetch_array($dane, MYSQLI_ASSOC);
        return $row['rodzaj'];
    }

}
