<?php

/**
 * Description of shop
 *
 * @author Jacek Pecko
 */
include_once('modules/function_create_link.php');

class shop {
    /*
     * return array
     * zwraca listę id zdjęć produktu
     */

    public function getPhotos($idrek) {
        global $dbc;
        $items = array();
        $tabela_shop_photo = Config::read('db.prefix') . 'shop_photo';
        $wynik = mysqli_query($dbc, "SELECT * FROM $tabela_shop_photo where `product_id` = $idrek ORDER BY `waga`;");
        while ($rekord = mysqli_fetch_array($wynik, MYSQLI_ASSOC)) {
            array_push($items, $rekord);
        }
        return $items;
    }

    /* return array
     *  zwraca listę dostęþnych koloróœ
     */

    public function getColors($idrek) {
        global $dbc;
        $items = array();
        $tabela_shop_photo = Config::read('db.prefix') . 'shop_photo';
        $wynik = mysqli_query($dbc, "SELECT `color` FROM $tabela_shop_photo where `product_id` = $idrek ORDER BY `waga`;");
        while ($rekord = mysqli_fetch_array($wynik, MYSQLI_ASSOC)) {
            if (strlen($rekord['color']) > 2)
                array_push($items, $rekord['color']);
        }
        if (count($items) == 0)
            return FALSE;

        $items = array_unique($items);
        return $items;
    }

    /*
     * Zwaraca url do produktu
     */

    public function getUrl($idrek) {
        global $dbc;
        $tabela_shop_product = Config::read('db.prefix') . 'shop_product';
        $wynik = mysqli_query($dbc, "SELECT `permalink` FROM $tabela_shop_product WHERE `idrek`='" . $idrek . "';");
        $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
        $permalink = $row['permalink'];

        $url = $this->getCategoryUrl($idrek) . 'p,' . $permalink . ',i,' . $idrek . '.html';


        if (!preg_match("/^http/", $url)) {
            if ($_SERVER['HTTPS'] == "on") {
                return 'https://' . $url;
            } else {
                return 'http://' . $url;
            }
        }
        return $url;
    }

    /*
     * Zwaraca url do produktu
     */

    public function getAddCardUrl($idrek) {
        global $dbc;
        $tabela_shop_product = Config::read('db.prefix') . 'shop_product';
        $wynik = mysqli_query($dbc, "SELECT `permalink` FROM $tabela_shop_product WHERE `idrek`='" . $idrek . "';");
        $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
        $permalink = $row['permalink'];

        $url = $this->getCategoryUrl($idrek) . 'p,' . $permalink . ',i,' . $idrek . ',add,1.html';


        if (!preg_match("/^http/", $url)) {
            if ($_SERVER['HTTPS'] == "on") {
                return 'https://' . $url;
            } else {
                return 'http://' . $url;
            }
        }
        return $url;
    }

    /*
     * zwraca url kategorii produktu
     */

    public function getCategoryUrl($idrek) {
        global $dbc;
        $url = create_link($this->getCategoryStructureId($idrek));
        if (!preg_match("/^http/", $url)) {
            if ($_SERVER['HTTPS'] == "on") {
                return 'https://' . $url;
            } else {
                return 'http://' . $url;
            }
        }
        return $url;
    }

    public function getCategoryStructureId($idrek) {
        global $dbc;
        $tabela_shop_product_category = Config::read('db.prefix') . 'shop_product_category';
        $wynik = mysqli_query($dbc, "SELECT `category_id` FROM $tabela_shop_product_category WHERE `product_id`='" . $idrek . "' ORDER BY waga LIMIT 0,1;");
        $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
        $category_id = $row['category_id'];

        $tabela_shop_category = Config::read('db.prefix') . 'shop_category';
        $wynik = mysqli_query($dbc, "SELECT `structureid` FROM $tabela_shop_category WHERE `idrek`='" . $category_id . "';");
        $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);

        return $row['structureid'];
    }

    /*
     * zwraca nazwę kateogii z produktem
     */

    public function getCategoryName($idrek) {
        $category = $this->getCategory($idrek);
        return $category[0]['title'];
    }

    /*
     * return array
     * zwraca listę id kategorii produktów wraz ze wszystkimi danymi
     * w 
     */

    public function getCategory($idrek) {
        global $dbc;
        $item_elem = array();
        $items = array();
        $tabela_shop_product_category = Config::read('db.prefix') . 'shop_product_category';
        $wynik = mysqli_query($dbc, "SELECT category_id FROM $tabela_shop_product_category where `product_id` = $idrek ORDER BY `waga`;");
        while ($rekord = mysqli_fetch_array($wynik, MYSQLI_ASSOC)) {
            array_push($item_elem, $rekord['category_id']);
        }

        for ($i = 0; $i < count($item_elem); $i++) {
            $tabela_shop_category = Config::read('db.prefix') . 'shop_category';
            $wynik = mysqli_query($dbc, "SELECT * FROM $tabela_shop_category WHERE `idrek`='" . $item_elem[$i] . "';");
            $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
            $row['url'] = $this->getCategoryUrl($idrek);
            array_push($items, $row);
        }

        return $items;
    }

    /*
     * return array
     * zwraca szczegóły produktu
     */

    public function getProduct($idrek, $active = FALSE) {
        global $dbc;
        $idrek = addslashes($idrek);
        $tabela_shop_product = Config::read('db.prefix') . 'shop_product';
        if ($active == FALSE)
            $wynik = mysqli_query($dbc, "SELECT * FROM $tabela_shop_product WHERE `idrek`='" . $idrek . "';");
        else
            $wynik = mysqli_query($dbc, "SELECT * FROM $tabela_shop_product WHERE `idrek`='" . $idrek . "' AND `active` = 'Y';");
        $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
        if ($row) {
            if ($row['seo_title'] == NULL OR $row['seo_title'] == '') {
                $metaTitle = strip_tags($row['name']);
                $row['seo_title'] = $metaTitle;
            }

            if ($row['seo_description'] == NULL OR $row['seo_description'] == '') {
                $metoDescripton = strip_tags($row['description']);
                $row['seo_description'] = limit($metoDescripton, 140);
            }

            $row['url'] = $this->getUrl($idrek);
            $row['urlCardAdd'] = $this->getAddCardUrl($idrek);
            $row['photos'] = $this->getPhotos($idrek);
            $row['categorys'] = $this->getCategory($idrek);
            return $row;
        } else {
            return false;
        }
    }

    /*
     * Sprawdzanie, czy produkt znajduje się w koszyku użytkownika
     * return TRUE lub FALSE
     */

    public function isProductInCard($idrek, $session) {
        global $dbc;
        $tabela_shop_product = Config::read('db.prefix') . 'shop_card';
        $wynik = mysqli_query($dbc, "SELECT COUNT(*) AS count FROM $tabela_shop_product WHERE `hash`='" . $session->getHash() . "' and `product_id` = $idrek;");
        $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
        if ($row['count'] > 0)
            return TRUE;
        else
            return FALSE;
    }

    /*
     *  Pobieranie szczegółów zamowienia o określonym id
     * Zabezpieczone przed czytaniem nie swoich zamówień
     * return array
     */

    public function getOrder($oId, $userId = FALSE) {
        global $dbc;
        if ($userId == FALSE)
            $userId = Config::read('user.id');


        $tabela_shop_order = Config::read('db.prefix') . 'shop_order';
        $wynik = mysqli_query($dbc, "SELECT *  FROM $tabela_shop_order WHERE `idrek`='" . $oId . "' and `created_by` = " . $userId . ";");
        $row = mysqli_fetch_array($wynik, MYSQLI_ASSOC);
        if ($row) {
            $licznik = 0;
            $row['sum'] = 0;
            $tabela_shop_order_products = Config::read('db.prefix') . 'shop_order_products';
            $wynik_shop_order_products = mysqli_query($dbc, "SELECT * FROM $tabela_shop_order_products where `other_id` = '" . $row['idrek'] . "';");
            while ($rekord = mysqli_fetch_array($wynik_shop_order_products, MYSQLI_ASSOC)) {
                $row['product'][$licznik] = $this->getProduct($rekord['product_id'], true);
                $row['product'][$licznik]['count'] = $rekord['count'];
                $row['product'][$licznik]['price'] = $rekord['price'];
                $row['sum'] = $row['sum'] + ($rekord['count'] * $rekord['price']);
                $licznik++;
            }
            return $row;
        } else
            return FALSE;
    }

    /*
     * Zwraca listę zamówień użytkownika - domyślnie session user
     * return array
     */

    public function getUserTransation($userId = FALSE) {
        global $dbc;
        if ($userId == FALSE)
            $userId = Config::read('user.id');
        $licznik = 0;
        $items = array();
        $tabela_shop_order = Config::read('db.prefix') . 'shop_order';
        $wynik_shop_order = mysqli_query($dbc, "SELECT * FROM $tabela_shop_order where `created_by` = '" . $userId . "';");
        while ($rekord = mysqli_fetch_array($wynik_shop_order, MYSQLI_ASSOC)) {
            $items[$licznik] = $rekord;
            $items[$licznik]['products'] = $this->getOrder($rekord['idrek'], $userId);
            $licznik++;
        }
        if (count($items) > 0)
            return $items;

        return FALSE;
    }

    public function getProductList() {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'shop_product';
        $tabela_shop_prod_cat = Config::read('db.prefix') . 'shop_product_category';
        $elements = array();
        $licznik = 0;

        $wynik = mysqli_query($dbc, "SELECT `idrek`, `created_date` FROM $tabela LEFT OUTER JOIN $tabela_shop_prod_cat ON $tabela.idrek=$tabela_shop_prod_cat.product_id where `active` = 'Y';");
        while ($rekord = mysqli_fetch_array($wynik, MYSQLI_ASSOC)) {
            $elements[$licznik] = $rekord;
            $elements[$licznik]['url'] = $this->getUrl($rekord['idrek']);
            $elements[$licznik]['photos'] = $this->getPhotos($rekord['idrek']);
            $licznik++;
        }

        return $elements;
    }

}
