<?php

/**
 * Description of SiteMaps
 *
 * @author IT-Poland.com Jacek Pecko
 */
class SiteMaps {

    public function crateDir($moduleName) {
        if ($moduleName != false) {
            $dir = Config::read('system.dir') . CMS_WORK_DIR . $moduleName . '/';
            if (!file_exists($dir)) {
                mkdir($dir, 0777);
            }
        } else {
            $dir = Config::read('system.dir') . CMS_WORK_DIR;
        }
        return $dir;
    }

    public function saveSiteMap($date, $dir, $moduleName) {

        $content = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\"
xmlns:image=\"http://www.google.com/schemas/sitemap-image/1.1\">";

        for ($i = 0; $i < count($date); $i++) {

            if (strlen($date[$i]['url'])>5) {
                $content.="
   <url>
      <loc>" . $date[$i]['url'] . "</loc>
      <lastmod>" . date("Y-m-d", $date[$i]['date']) . "</lastmod>";

                for ($i2 = 0; $i2 < count($date[$i]['photos']); $i2++) {
                    $content.="<image:image>
                    <image:loc>" . $date[$i]['photos'][$i2] . "</image:loc>
                </image:image>";
                }


                $content.="            
   </url>                
";
            }
        }
        $content.="</urlset> ";
        // file_put_contents($dir . 'sitemap.xml', $content, FILE_APPEND | LOCK_EX);
        $out = fopen($dir . 'sitemap.xml', "w");
        fwrite($out, $content);
        fclose($out);
        return $moduleName . '/sitemap.xml';
    }

}
