<?php

/**
 * Description of session
 *
 * @author IT-Poland.com Jacek Pecko
 */
class User {

    private $userIsLoged = NULL, $tableUser, $tableCounter;

    public function __construct() {
        $this->tableUser = Config::read('db.prefix') . 'users';
        $this->tableCounter = Config::read('db.prefix') . 'counters';

        $this->setUserIsLoged($this->UserIsLoged());
    }

    public function UserIsLoged($userId = 0) {
        global $dbc;
        if ($userId == 0 AND ( Config::read('user.group') == 14 OR Config::read('user.group') == 12 OR Config::read('user.group') == 3 OR Config::read('user.group') == 2)) {
            return TRUE;
        } else if ($userId != 0) {
            $tabela = Config::read('db.prefix') . 'session';
            $wynik = mysqli_query($dbc, "SELECT `idrek` FROM $tabela WHERE `userid`='$userId';");
            $row = mysqli_fetch_array($wynik, MYSQLI_BOTH);
            if ($row['idrek'] > 0) {
                return TRUE;
            } else {
                return FALSE;
            }
        } else {
            return FALSE;
        }
    }

//sprawdza czy użytkownik z facebooka konto na serwisie
    public function isFacebookAcount($fbID) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'users';
        $dane = mysqli_query($dbc, "SELECT `idrek` FROM $tabela WHERE `fbID` = '$fbID';");
        $row = mysqli_fetch_array($dane);
        if ($row['idrek'] > 0) {
            return $row['idrek'];
        } else {
            return false;
        }
    }

    public function isLoginFree($login) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'users';
        $dane = mysqli_query($dbc, "SELECT `idrek` FROM $tabela WHERE `nick` = '$login';");
        $row = mysqli_fetch_array($dane);
        if ($row['idrek'] > 0) {
            return false;
        } else {
            return true;
        }
    }

    public function isLoginCorrect($login) {
        global $dbc;
        if (strlen($login) < 3) {
            return 'Login musi mieć przynajniej trzy znaki.';
        } else if (ereg('[^a-zA-Z0-9\-]', $login)) {
            return 'Podany przez Ciebie login jest nie prawidłowy. Dozwolone są jedynie litery (bez polskich znaków), cyfry oraz "-".';
        }
        if (strlen($login) > 25) {
            return 'Login nie może mieć więcej niż 25 znaków.';
        } else {
            return true;
        }
    }

    public function checkAccountByEmial($email) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'users';
        $dane = mysqli_query($dbc, "SELECT `idrek`, `idgroup` FROM $tabela WHERE `mail` = '$email';");
        $row = mysqli_fetch_array($dane, MYSQLI_ASSOC);
        if ($row['idrek'] > 0) {
            return $row;
        } else {
            return false;
        }
    }

    public function activeAccount($userId) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'users';
        $row_name = array();
        $row_value = array();
        array_push($row_name, 'idgroup');
        array_push($row_value, 2);
        update_sql($tabela, $row_name, $row_value, '`idrek`=\'' . $userId . '\'');
    }

    public function getUserMinDate($userID) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'users';
        $dane = mysqli_query($dbc, "SELECT `idrek`, `idgroup`,  `photo_id`, `sex`, `nick`, `name`, `surname`, `show_only_login`, `fbID` , `FB_updated_time`, `mail`   FROM $tabela WHERE `idrek` = '$userID';");
        $row = mysqli_fetch_array($dane, MYSQLI_ASSOC);
        if ($row['idrek'] > 0) {
            return $row;
        } else {
            return false;
        }
    }

//funkcja używana  w części modułó - wypadał - to jest alias
    public function getUserById($userID = null) {
        if ($userID == null) {
            $userID = Config::read('user.id');
        }
        return $this->getUserFullDate($userID);
    }

    public function getUserFullDate($userID) {
//tymczasowo - docelowo pełne dane - powinna być kompatybilna z getUserMinDate
        return $this->getUserMinDate($userID);
    }

    public function logedUser($userDate) {
        global $dbc;

        $userid = $userDate['idrek'];
        $userGroup = $this->getUserGroup($userDate['idrek']);
        $webuser['nick'] = $this->getUserLogin($userid);


//$webuser['nick'] = $userDate['nick'];
        $show_only_login = $userDate['show_only_login'];
        $ip = $_SERVER['REMOTE_ADDR'];
        $host = gethostbyaddr($ip);
        $tabela = Config::read('db.prefix') . 'logs';

        $row_name = array();
        $row_value = array();
        array_push($row_name, 'iduser');
        array_push($row_value, $userid);
        array_push($row_name, 'ip');
        array_push($row_value, $ip);
        array_push($row_name, 'host');
        array_push($row_value, $host);
        array_push($row_name, 'date');
        array_push($row_value, 'NOW()');
        array_push($row_name, 'idoperation');
        array_push($row_value, 'LOGIN_USER');
        insert_sql($tabela, $row_name, $row_value);


        $tabela = Config::read('db.prefix') . 'session';
        $hash = $_COOKIE[Config::read('session.cookiename')];

        $row_name = array();
        $row_value = array();
        array_push($row_name, 'userid');
        array_push($row_value, $userid);
        array_push($row_name, 'group');
        array_push($row_value, $userGroup);
        array_push($row_name, 'nick');
        array_push($row_value, $webuser['nick']);
        array_push($row_name, 'show_only_login');
        array_push($row_value, $show_only_login);
        if ($_POST['hide_me'] == "1") {
            array_push($row_name, 'hide_me');
            array_push($row_value, "Y");
        } else {
            array_push($row_name, 'hide_me');
            array_push($row_value, "N");
        }
        if ($row['sex'] == "W")
            $content = 'zalogowała się';
        else
            $content = 'zalogował się';

//what_new($row['idrek'], $content);  

        update_sql($tabela, $row_name, $row_value, '`hash`=\'' . $hash . '\'');


        /* koszyk - uzupełnienie wydania o ID */
        $tabela = Config::read('db.prefix') . 'shop_card';
        $row_name = array();
        $row_value = array();
        array_push($row_name, 'user_id');
        array_push($row_value, $userid);
        update_sql($tabela, $row_name, $row_value, '`hash`=\'' . $hash . '\'');

        /* KONIEC koszyk - uzupełnienie wydania */

        return true;
    }

    public function logoutUser() {
        global $dbc;
        $sessionObj = new Session();
        $hash = $sessionObj->getHash();
        $tabela = Config::read('db.prefix') . 'users';
        $wynik = mysqli_query($dbc, "SELECT `idrek`, `photo_id`, `sex`, `nick`, `name`, `surname`, `show_only_login` FROM $tabela WHERE `idrek`='" . Config::read('user.id') . "';");
        $row = mysqli_fetch_array($wynik, MYSQLI_BOTH);
        if ($row[0] > 0) {
            if ($webuser['hide_me'] == "N") {
                if ($row['sex'] == "W")
                    $content = 'wylogowała się';
                else
                    $content = 'wylogował się';

                what_new($row['idrek'], $content, $row['photo_id']);
            }
        }

        Config::write('user.id', 0);
        Config::write('user.nick', NULL);
        Config::write('user.group', 15);

        $tabela = Config::read('db.prefix') . 'session';
        $row_name = array();
        $row_value = array();
        array_push($row_name, 'userid');
        array_push($row_value, '0');
        array_push($row_name, 'group');
        array_push($row_value, '15');
        array_push($row_name, 'nick');
        array_push($row_value, '');

        update_sql($tabela, $row_name, $row_value, '`hash` = \'' . $hash . '\'');

        return TRUE;
    }

//aktualizacja rekordu użytkownika o dane z FB
    public function updateUserFB($param) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'users';
        $row_name = array();
        $row_value = array();
        array_push($row_name, 'fbID');
        array_push($row_value, $param['id']);
        array_push($row_name, 'FB_updated_time');
        array_push($row_value, $param['updated_time']);
        update_sql($tabela, $row_name, $row_value, '`idrek`=\'' . $param['userID'] . '\'');
    }

//aktualizacja rekordu użytkownika o dane G+
//aktualizacja rekordu użytkownika o dane z FB
    public function updateUserGP($param) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'users';
        $row_name = array();
        $row_value = array();
        array_push($row_name, 'googleID');
        array_push($row_value, $param['id']);
        update_sql($tabela, $row_name, $row_value, '`idrek`=\'' . $param['userID'] . '\'');
    }

    public function getUserGroup($userID) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'users';
        $dane = mysqli_query($dbc, "SELECT `idrek`, `idgroup` FROM $tabela WHERE `idrek` = '$userID';");
        $row = mysqli_fetch_array($dane, MYSQLI_ASSOC);
        if ($row['idrek'] > 0) {
            return $row['idgroup'];
        } else {
            return false;
        }
    }

    public function getUserLogin($userID) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'users';
        $dane = mysqli_query($dbc, "SELECT `idrek`, `nick` FROM $tabela WHERE `idrek` = '$userID';");
        $row = mysqli_fetch_array($dane, MYSQLI_ASSOC);
        if ($row['idrek'] > 0) {
            return $row['nick'];
        } else {
            return false;
        }
    }

    public function getUserEmail($userID) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'users';
        $dane = mysqli_query($dbc, "SELECT `mail` FROM $tabela WHERE `idrek` = '$userID';");
        $row = mysqli_fetch_array($dane, MYSQLI_ASSOC);
        if ($row) {
            return $row['mail'];
        } else {
            return false;
        }
    }

    public function getUserProfileUrl($userId = 0) {
        global $dbc;
        global $core;
        if ($userId == 0)
            $userId = Config::read('user.id');
        $userLogin = $this->getUserLogin($userId);
        if (!$userLogin)
            return false;
        if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off')
            return 'https://' . Config::read('site.domain') . '/uzytkownicy/' . $userLogin . '/';
        else
            return 'http://' . Config::read('site.domain') . '/uzytkownicy/' . $userLogin . '/';
    }

    public function getCreatedDate($userId = 0) {
        global $dbc;
        global $core;
        if ($userId == 0)
            $userId = Config::read('user.id');
        $tabela = Config::read('db.prefix') . 'users';
        $sql = "SELECT `created_date` FROM $tabela WHERE `idrek`=" . $userId;
        $result = $core->dbh->prepare($sql);
        $result->execute();
        $row = $result->fetch(PDO::FETCH_ASSOC);

        return $row['created_date'];
    }

    public function recoverPassStep1($email) {
        global $dbc;
        $tabela = Config::read('db.prefix') . 'users';
        $wynik = mysqli_query($dbc, "SELECT `idrek`, `key`, `mail` FROM $tabela WHERE `mail`='$email' AND (`idgroup`='12' OR `idgroup`='3' OR `idgroup`='2') AND (`recoverPass` < '" . date("Y-m-d") . "' OR `recoverPass` IS NULL);");
        $row = mysqli_fetch_array($wynik, MYSQLI_BOTH);
        if ($row['idrek']) {
            $newHash = $row['key'] . md5(date("d"));
            $content = '<h2>Odzyskiwanie hasła w serwisie ' . Config::read('site.domainVisible') . '</h2><br /><br />'
                    . 'Witaj,<br />'
                    . 'ktoś, prawdopodobnie Ty poprosił o odzyskanie hasła w serwisie ' . Config::read('site.domainVisible') . '<br /><br />'
                    . 'Aby dokończyć proces kliknij w poniższy link:<br />'
                    . '<a href="https://' . Config::read('site.domain') . '/odzyskiwanie-hasla/s,2,key,' . $newHash . ',d,' . $row['idrek'] . '.html" target="_blank">https://' . Config::read('site.domain') . '/odzyskiwanie-hasla/s,2,key,' . $newHash . ',d,' . $row['idrek'] . '.html</a><br /><br />'
                    . '<br /><br /><br />'
                    . 'Pozdrawiamy<br />';
            send_mail($email, Config::read('email.name'), Config::read('email.adress'), 'Odzyskiwanie hasła w serwisie ' . Config::read('site.domainVisible'), $content);

            $tabela = Config::read('db.prefix') . 'users';
            $row_name = array();
            $row_value = array();
            array_push($row_name, 'recoverPass');
            array_push($row_value, date("Y-m-d"));
            array_push($row_name, 'recoverPass_last_ip');
            array_push($row_value, $_SERVER['REMOTE_ADDR']);
            update_sql($tabela, $row_name, $row_value, '`idrek`=\'' . $row['idrek'] . '\'');

            return TRUE;
        }

        return FALSE;
    }

    public function recoverPassVeryficationStep2($param) {
        global $dbc;
        $userId = addslashes($param['d']);
        $tabela = Config::read('db.prefix') . 'users';
        $wynik = mysqli_query($dbc, "SELECT `idrek`, `key` FROM $tabela WHERE `idrek` = '$userId' AND (`idgroup` = '12' OR `idgroup` = '3' OR `idgroup` = '2');
");
        $row = mysqli_fetch_array($wynik, MYSQLI_BOTH);
        if ($row) {
            if ($row['key'] . md5(date("d")) == $param['key']) {
                return $row['idrek'];
            }
        }
        return FALSE;
    }

    /* Sprawdzanie czy hasło jest poprawne */

    public function isPassCorect($pass1, $pass2) {
        global $dbc;
        if (strlen($pass1) < 5)
            return 'Hasło powinno mieć co najmniej 5 znaków.';

        if ($pass1 != $pass2)
            return 'Hasła różnią się od siebie.';

        return TRUE;
    }

    /* Rejestracja */

    /* gettery i settery */

    function getUserIsLoged() {
        return $this->userIsLoged;
    }

    function setUserIsLoged($userIsLoged) {
        $this->userIsLoged = $userIsLoged;
    }

    public function delUser() {
        global $dbc;
        $query = "DELETE from $this->tableCounter WHERE `kogo` = '" . Config::read('user.id') . "';";
        $wynik = mysqli_query($dbc, $query);

        $query = "DELETE from $this->tableUser WHERE `idrek` = '" . Config::read('user.id') . "';";
        $wynik = mysqli_query($dbc, $query);

        $content = '<h2>Usunięcie konta ' . Config::read('site.domainVisible') . '</h2><br /><br />'
                . 'Użytkownk usunął konto.';

        send_mail(Config::read('system.adminEmail'), Config::read('email.name'), Config::read('email.adress'), 'Rejestracji w serwisie ' . Config::read('site.domainVisible'), $content);

        $this->logoutUser();

        header('Location: https://' . Config::read('site.domain'));
        exit;
    }

}
